from pattern.en import lemma as _pattern_lemma
from pattern.en import parse, tag
import spacy
from spacy.lang import en
# ------------------------------------------------ spacy
spacy_poslemmatizer = en.EnglishDefaults.create_lemmatizer()
spacy_model = spacy.load('en_core_web_sm', disable=['parser', 'ner'])


def spacy_lemma(text, lowercase=True):
    
    if lowercase:
        text = text.lower()
        
    doc = spacy_model(text)
    lemmas = " ".join([token.lemma_ if token.lemma_ !="-PRON-" else token.lower_ for token in doc])
    tags = " ".join([token.tag_ for token in doc])    
    
    lemmas = lemmas.replace(" - ", "-") #spacy lemmatize twenty-five —> twenty - five, one solution may bea to space base tokenizer
    return (lemmas, tags)[0]


def spacy_poslemma(text, pos='verb', lowercase=True):

    if lowercase:
        text = text.lower()
        
    return spacy_poslemmatizer(text, pos)[0]


def spacy_postag(text):
    doc = spacy_model(text)
    tags = " ".join([token.tag_  for token in doc])
    return tags
# ------------------------------------------------ pattern https://github.com/clips/pattern    
def pattern_lemma(text, lowercase=True):
    if lowercase:
        text = text.lower()
   
    tokens = text.split(' ')
    lemmas = " ".join([_pattern_lemma(token) if token!="" else token for token in tokens])
    return lemmas


def pattern_postag(text):
    tagged_text = tag(text)
    tags = " ".join([token[1] for token in tagged_text])
    return tags
# ------------------------------------------------

# Fixing pattern bug
from lemmatize_util import pattern_lemma
try:
    pattern_lemma('Progress')
except:
    pass
# -------------------------------------------------
